function F = CSTRFun(x,params)
% Defines a four dimensional function based
% on the variable x (1x4 vector)
% the reaction parameters params (structure with three elements)

k = params.k;
t = params.t;
xin = params.xin;

F = [xin(1) - x(1) + t*(-k(1)*x(1)*x(2));
     xin(2) - x(2) + t*(-k(1)*x(1)*x(2) - k(2)*x(2)*x(3));
            - x(3) + t*(+k(1)*x(1)*x(2) - k(2)*x(2)*x(3));
            - x(4) + t*k(2)*x(2)*x(3)];