function J = CSTRJac(x,params)
% Defines a four dimensional Jacobian matrix based
% on the variable x (1x4 vector)
% the reaction parameters params (structure with two fields, k has 2 elements)


k = params.k;
t = params.t;

J = [-1-t*k(1)*x(2),    -t*k(1)*x(2),   0,  0;
     -t*k(1)*x(2),      -1-t*(k(1)*x(1)+k(2)*x(3)),     -t*k(2)*x(2), 0;
      t*k(1)*x(2),      t*(k(1)*x(1) - k(2)*x(3)),  -1-t*k(2)*x(2), 0;
      0,                t*k(2)*x(3),                t*k(2)*x(2), -1];