% Numerical and Statistical Methods 2023
% Exercise 3, Assignment 3
clear all; close all; clc;

% Q3.1 Calculate Jacobian analytically; refer to mfile 'CSTRJac.m'

% Q3.2-3
%% Define constants of reaction system
params.k = [0.5; 10];
params.xin = [1, 1.5];
params.t = 5;
%% Define tolerances and initial conditions for solution
tol = [1e-6, 1e-8, 100];
x0 = [1; 1; 1; 1];

%% Solve the system
% fsolve
tic;
x = fsolve(@(x)CSTRFun(x,params),x0);
t = toc;
fprintf('\nfsolve:\n')
fprintf(' A = %g\n B = %g\n C = %g\n D = %g\n',x)
fprintf(' Conversion = %.4g%%\n',100*x(4)/params.xin(1))
fprintf('\t\t \t Time needed: %g seconds.\n\n',t)

% Analytical Jacobian
fprintf('Analytical Jacobian:\n')
tic;
[x, info] = newtonMethod(@(x)CSTRFun(x,params),@(x)CSTRJac(x,params),x0, tol);
t = toc;
fprintf(' A = %g\n B = %g\n C = %g\n D = %g\n',x(end, :))
fprintf(' Conversion = %.4g%%\n',100*x(end,4)/params.xin(1))
fprintf('Number of steps: %d, \t Time needed: %g seconds.\n\n',info.nIter,t)

% Q3.4 Numerical Jacobian
fprintf('Numerical Jacobian:\n')
tic;
[x, info] = newtonMethod(@(x)CSTRFun(x,params),[],x0, tol);
t = toc;
fprintf(' A = %g\n B = %g\n C = %g\n D = %g\n',x(end, :))
fprintf(' Conversion = %.4g%%\n',100*x(end,4)/params.xin(1))
fprintf('Number of steps: %d, \t Time needed: %g seconds.\n\n',info.nIter,t)

