function [x, info] = newtonMethod(f, J, x0, tol)

    x(1,:) = x0;
    n = 1;
    diff = (tol(1) + 1)*ones(size(x(1, :)));

    if isempty(J)
        J = @(x)jacobianest(f,x);
    end



    while norm(diff) > tol(1) && norm(f(x(n, :))) > tol(2) && n <= tol(3) 
        Jx = J(x(n, :));
        fx = f(x(n, :));
        dx = (Jx\-fx)';
        x(n+1, :) = x(n, :) + dx;
        diff = dx; 
        n = n + 1;

    end


    if norm(diff) < tol(1)
       info.nIter = n;
       info.residual = norm(fx);
       info.status = 'Step'; 
    end

    if norm(f(x(end, :))) < tol(2)
       info.nIter = n;
       info.residual = norm(f(x(end, :)));
       info.status = 'F-norm'; 
    end

    if n > tol(3)
       info.nIter = n;
       info.residual = norm(fx);
       info.status = 'Max Iterations'; 
    end


end